#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <dos.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#define MAXNOTES 4096

typedef struct
{
	unsigned short freq;
	unsigned char duration;
} NOTE;

short bps;
int numnotes;
NOTE note[MAXNOTES];

int main(int argc, char *argv[])
{
	int i, handle, siz;
	
	if (argc < 2)
	{
		printf("PCSPLAY v1.0	- By Michael Muniko\n");
		printf("This will play Prince of Persia PC Speaker sounds\n");
		printf("Syntax: pcsplay [pc speaker file]\n");
		exit(0);
	}

	if ((handle = open(argv[1], O_BINARY|O_RDONLY,S_IREAD)) == -1)
	{
		printf("Cannot open %s\n", argv[1]);
		exit(-1);
	}
	i = 0;
	siz = filelength(handle);
	read(handle,&bps,2);
	read(handle,&note[0],siz - 2);
	close(handle);
	outp(0x43, 0xb6);
	outp(0x42, (1193181/bps)&255);
	outp(0x42, (1193181/bps)>>8);
	printf("Playing %s.....\n", argv[1]);
	while (note[i].freq != 0x12)
	{
		sound(note[i].freq);
		if (note[i].freq == 0) nosound();
		delay(note[i].duration*4);
		i++;
	}
	nosound();
	return(0);
}
